//Basic timer object

class _timer
{
public:
	_timer();
	float GetTime();

private:
	__int64			frequency;
	float			resolution;
	unsigned long	mm_timer_start;
	unsigned long	mm_timer_elapsed;
	bool			performance_timer;
	__int64			performance_timer_start;
	__int64			performance_timer_elapsed;
};

_timer::_timer()
{
	if (!QueryPerformanceFrequency((LARGE_INTEGER *) &frequency))
	{
		performance_timer	= FALSE;
		mm_timer_start		= GetTickCount();
		resolution			= 1.0f/1000.0f;
		frequency			= 1000;
		mm_timer_elapsed	= mm_timer_start;
	}
	else
	{
		QueryPerformanceCounter((LARGE_INTEGER *) &performance_timer_start);
		performance_timer			= TRUE;
		resolution					= (float) ( ( (double) 1.0f) / ( (double) frequency ) );
		performance_timer_elapsed	= performance_timer_start;
	}
}

float _timer::GetTime()
{
	if (performance_timer)
	{
		__int64 time;
		QueryPerformanceCounter((LARGE_INTEGER *) &time);
		return ( (float) ( time - performance_timer_start ) * resolution) * 1000.0f;
	}
	else
	{
		return( (float) ( GetTickCount() - mm_timer_start ) * resolution) * 1000.0f;
	}
}
